/*
 *  multinomial_sampler.cpp
 *  
 *
 *  Created by Roni Mittelman on 9/18/12.
 *  Copyright 2012 University of Michigan. All rights reserved.
 *
 */

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include "mex.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[]){
    // input: cumsumPV, sortedY, num_of_words, MiniBatchLen, NVisible, max_num_of_words
	if (nrhs != 6) {
		mexErrMsgTxt("multinomial_sampler requires 6 input arguments.");
	} else if (nlhs > 1) {
		mexErrMsgTxt("One output argument required");
	}
	
	int MiniBatchLen= (int)*mxGetPr(prhs[3]);
	int max_num_of_words=(int)*mxGetPr(prhs[5]);
	int NVisible=(int)*mxGetPr(prhs[4]);
	int num_of_words[MiniBatchLen];
	double sortedY[max_num_of_words];
	double cumsumPV[NVisible];
	int i,j,cnt;
	
	
	int ndims={2};
	int dims[2];
	dims[0]=MiniBatchLen;
	dims[1]=NVisible;
	plhs[0] = mxCreateNumericArray(ndims,dims,mxDOUBLE_CLASS,mxREAL);
	
	double *Ptr,*Ptr2,*Ptr3;
	
	double *output;
	output = mxGetPr(plhs[0]);
	
	Ptr = mxGetPr(prhs[2]); 
	Ptr2 = mxGetPr(prhs[0]); 
	Ptr3 = mxGetPr(prhs[1]); 
	//std::cout << "00\n";
	for (i=0;i<MiniBatchLen;i++){
		num_of_words[i]=(int)Ptr[i];
		//std::cout << "11\n";
		for (j=0;j<NVisible;j++){
			cumsumPV[j]=(double)Ptr2[i+j*MiniBatchLen];
			output[i+j*MiniBatchLen]=0.0;
		}
		//std::cout << "22\n";
		for (j=0;j<num_of_words[i];j++){
			sortedY[j]=(double)Ptr3[i+j*MiniBatchLen];
		}
		cnt=0;
		//std::cout << "33\n";
		//if ((cumsumPV[0]==0.0) && (cumsumPV[NVisible-1]==0.0)){
//			//std::cout<<"error "<<"\n";
//			continue;
//		}
		for (j=0;j<num_of_words[i];j++){
			if (cnt==NVisible-1){
				output[i+cnt*MiniBatchLen]++;
			}
			else{
				if (cnt>=NVisible){
					std::cout<<cnt<<" "<<num_of_words[i]<<" "<<NVisible<<"\n";
					std::cout<<"error "<<i<<" "<<j<<" "<<sortedY[j]<<" "<<sortedY[0]<<" "<<cumsumPV[0]<<" "<<cumsumPV[NVisible-1]<<"\n";
					return;
				}

				while (!(sortedY[j]<cumsumPV[cnt])) {
					if (cnt==NVisible-1){
						break;
					}					
					cnt++;
					if (cnt>NVisible){
						std::cout<<cnt<<" "<<num_of_words[i]<<" "<<NVisible<<"\n";
						std::cout<<"error "<<i<<" "<<j<<" "<<sortedY[j]<<" "<<sortedY[0]<<" "<<cumsumPV[0]<<" "<<cumsumPV[NVisible-1]<<"\n";
						return;
					}
				}
				//std::cout << "88\n";
				if (cnt<NVisible){
					output[i+cnt*MiniBatchLen]++;
				}
			}
		}
	}
}